function slideUp(target, duration) {
  target.style.transitionProperty = "height, margin, padding";
  target.style.transitionDuration = duration + "ms";
  target.style.boxSizing = "border-box";
  target.style.height = target.offsetHeight + "px";
  target.offsetHeight;
  target.style.overflow = "hidden";
  target.style.height = 0;
  target.style.paddingTop = 0;
  target.style.paddingBottom = 0;
  target.style.marginTop = 0;
  target.style.marginBottom = 0;
  window.setTimeout(function () {
    target.style.display = "none";
    target.style.removeProperty("height");
    target.style.removeProperty("padding-top");
    target.style.removeProperty("padding-bottom");
    target.style.removeProperty("margin-top");
    target.style.removeProperty("margin-bottom");
    target.style.removeProperty("overflow");
    target.style.removeProperty("transition-duration");
    target.style.removeProperty("transition-property");
  }, duration);
}

function slideDown(target, duration) {
  target.style.removeProperty("display");
  var display = window.getComputedStyle(target).display;

  if (display === "none") display = "block";

  target.style.display = display;
  var height = target.offsetHeight;
  target.style.overflow = "hidden";
  target.style.height = 0;
  target.style.paddingTop = 0;
  target.style.paddingBottom = 0;
  target.style.marginTop = 0;
  target.style.marginBottom = 0;
  target.offsetHeight;
  target.style.boxSizing = "border-box";
  target.style.transitionProperty = "height, margin, padding";
  target.style.transitionDuration = duration + "ms";
  target.style.height = height + "px";
  target.style.removeProperty("padding-top");
  target.style.removeProperty("padding-bottom");
  target.style.removeProperty("margin-top");
  target.style.removeProperty("margin-bottom");
  window.setTimeout(function () {
    target.style.removeProperty("height");
    target.style.removeProperty("overflow");
    target.style.removeProperty("transition-duration");
    target.style.removeProperty("transition-property");
  }, duration);
}

function slideToggle(target, duration) {
  if (window.getComputedStyle(target).display === "none") {
    return slideDown(target, duration);
  } else {
    return slideUp(target, duration);
  }
}

function setupAccordion() {
  var pattern = new RegExp("^[\\w\\-]+$");
  var hashval = window.location.hash.substring(1);
  var expandFirstelements = document.getElementsByClassName(
    "easy-gtblocks-accordion-expand-first-true"
  );
  var inactiveOtherelements = document.getElementsByClassName(
    "easy-gtblocks-accordion-inactive-other-false"
  );

  if (pattern.test(hashval)) {
    var elementToOpen = document.getElementById(hashval);
    elementToOpen
      .getElementsByClassName(
        "easy-gtblocks-accordion-item"
      )[0]
      .classList.add("easy-gtblocks-accordion-item-active");
    elementToOpen
      .getElementsByClassName(
        "easy-gtblocks-accordion-item"
      )[0]
      .setAttribute("aria-expanded", true);
    slideDown(
      elementToOpen.getElementsByClassName(
        "easy-gtblocks-accordion-content"
      )[0],
      500
    );
  } else {
    for (var item = 0; item < expandFirstelements.length; item++) {
      if (
        true ===
        expandFirstelements[item].classList.contains(
          "easy-gtblocks-accordion-layout-accordion"
        )
      ) {
        expandFirstelements[item]
          .querySelectorAll(
            ".easy-gtblocks-accordion-item__outer-wrap"
          )[0]
          .getElementsByClassName(
            "easy-gtblocks-accordion-item"
          )[0]
          .classList.add(
            "easy-gtblocks-accordion-item-active"
          );
        expandFirstelements[item]
          .querySelectorAll(
            ".easy-gtblocks-accordion-item__outer-wrap"
          )[0]
          .getElementsByClassName(
            "easy-gtblocks-accordion-item"
          )[0]
          .setAttribute("aria-expanded", true);
        expandFirstelements[item]
          .querySelectorAll(
            ".easy-gtblocks-accordion-item__outer-wrap"
          )[0]
          .getElementsByClassName(
            "easy-gtblocks-accordion-item"
          )[0]
          .querySelectorAll(
            ".easy-gtblocks-accordion-content"
          )[0].style.display = "block";
      }
    }
  }
  for (var item = 0; item < inactiveOtherelements.length; item++) {
    if (
      true ===
      inactiveOtherelements[item].classList.contains(
        "easy-gtblocks-accordion-layout-accordion"
      )
    ) {
      var otherItems = inactiveOtherelements[item].querySelectorAll(
        ".easy-gtblocks-accordion-item__outer-wrap"
      );

      for (var childItem = 0; childItem < otherItems.length; childItem++) {
        otherItems[childItem]
          .getElementsByClassName(
            "easy-gtblocks-accordion-item"
          )[0]
          .classList.add(
            "easy-gtblocks-accordion-item-active"
          );
        otherItems[childItem]
          .getElementsByClassName(
            "easy-gtblocks-accordion-item"
          )[0]
          .setAttribute("aria-expanded", true);
        otherItems[childItem]
          .getElementsByClassName(
            "easy-gtblocks-accordion-item"
          )[0]
          .querySelectorAll(
            ".easy-gtblocks-accordion-content"
          )[0].style.display = "block";
      }
    }
  }
}

window.addEventListener("load", function () {
  setupAccordion();

  var accordionElements = document.getElementsByClassName(
    "easy-gtblocks-accordion-layout-accordion"
  );
  for (var item = 0; item < accordionElements.length; item++) {
    var titleButtons = accordionElements[item].querySelectorAll(
      ".easy-gtblocks-accordion-titles-button"
    );

    for (var button = 0; button < titleButtons.length; button++) {
      titleButtons[button].addEventListener("click", function (e) {
        accordionClick(e, this.parentElement, titleButtons);
      });
      titleButtons[button].addEventListener("keypress", function (e) {
        accordionClick(e, this.parentElement, titleButtons);
      });
    }
  }
});

function accordionClick(e, accordionItem, titleButtons) {
  e.preventDefault();

  if (
    accordionItem.classList.contains(
      "easy-gtblocks-accordion-item-active"
    )
  ) {
    accordionItem.classList.remove(
      "easy-gtblocks-accordion-item-active"
    );
    accordionItem.setAttribute("aria-expanded", false);
    slideUp(
      accordionItem.getElementsByClassName(
        "easy-gtblocks-accordion-content"
      )[0],
      500
    );
  } else {
    var parent =
      accordionItem.parentElement.parentElement.parentElement.parentElement;
    var accordionToggle = "true";
    if (
      parent.classList.contains(
        "wp-block-easy-gtblocks-accordion"
      )
    ) {
      accordionToggle = parent.getAttribute("data-accordiontoggle");
    }
    accordionItem.classList.add(
      "easy-gtblocks-accordion-item-active"
    );
    accordionItem.setAttribute("aria-expanded", true);
    slideDown(
      accordionItem.getElementsByClassName(
        "easy-gtblocks-accordion-content"
      )[0],
      500
    );
    if ("true" === accordionToggle) {
      for (
        var buttonChild = 0;
        buttonChild < titleButtons.length;
        buttonChild++
      ) {
        var buttonItem = titleButtons[buttonChild].parentElement;
        if (buttonItem === accordionItem) {
          continue;
        }
        buttonItem.classList.remove(
          "easy-gtblocks-accordion-item-active"
        );
        buttonItem.setAttribute("aria-expanded", false);
        slideUp(
          buttonItem.getElementsByClassName(
            "easy-gtblocks-accordion-content"
          )[0],
          500
        );
      }
    }
  }
}
