/**
 * BLOCK: Easy GT Blocks Buttons
 */

// Import block dependencies and components
import Edit from "./components/edit";
import Save from "./components/save";

// Import CSS
import "./styles/style.scss";
import "./styles/styles.editor.scss";

// Internationalization
const { __ } = wp.i18n;

const buttons = [];

for (var i = 1; i <= 2; i++) {
  var label = "#Click Here";
  var link = "#";
  buttons.push({
    label: label,
    link: link,
    size: "",
    vPadding: 10,
    hPadding: 14,
    borderWidth: 1,
    borderRadius: 2,
    borderStyle: "solid",
    borderColor: "",
    borderHColor: "",
    color: "",
    background: "",
    hColor: "",
    hBackground: "",
    sizeType: "px",
    sizeMobile: "",
    sizeTablet: "",
    lineHeight: "",
    lineHeightType: "em",
    lineHeightMobile: "",
    lineHeightTablet: "",
  });
}

// Register block
const { registerBlockType } = wp.blocks;

// Register the block
registerBlockType("easy-gtblocks/buttons", {
  title: __("Multi Buttons", "easy-gtblocks"),
  description: __(
    "Add buttons to group together.",
    "easy-gtblocks"
  ),
  icon: "button",
  category: "Easy_GTBlocks",
  keywords: [
    __("buttons", "easy-gtblocks"),
    __("multi buttons", "easy-gtblocks"),
    __("responsive", "easy-gtblocks"),
  ],
  example: {},
  attributes: {
    buttonAlignment: {
      type: "string",
      default: "center",
    },
    buttonAlignmentTablet: {
      type: "string",
      default: "center",
    },
    buttonAlignmentMobile: {
      type: "string",
      default: "center",
    },
    buttons: {
      type: "array",
      default: buttons,
    },
    gap: {
      type: "number",
      default: 10,
    },
    stack: {
      type: "string",
      default: "none",
    },
    btn_count: {
      type: "number",
      default: 2,
    },
  },
  EASY_GTBLOCKS_settings_data: {
    EASY_GTBLOCKS_button_buttonAlignment: {
      title: __("Alignment", "easy-gtblocks"),
    },
  },
  /* Render the block in the editor. */
  edit: (props) => {
    return <Edit {...props} />;
  },

  /* Save the block markup. */
  save: (props) => {
    return <Save {...props} />;
  },
});
