/**
 * WordPress dependencies
 */
import domReady from "../../../node_modules/@wordpress/dom-ready";

/**
 * Permanently hide the dismissible notification if clicked.
 */

domReady(() => {
  const elems = document.querySelectorAll(
    ".easy-gtblocks-block-expand"
  );
  elems.forEach((el) => {
    const btn = el.querySelector(
      ".easy-gtblocks-expand-toggle"
    );

    const clickHandler = (e) => {
      el.classList.toggle("easy-gtblocks-expand--more");
      const isExpanded = el.classList.contains(
        "easy-gtblocks-expand--more"
      );
      btn.setAttribute("aria-expanded", isExpanded ? "true" : "false");

      e.preventDefault();
    };
    if (btn) {
      btn.addEventListener("click", clickHandler);
      btn.addEventListener("tapEnd", clickHandler);
    }
  });
});
