/**
 * Internal dependencies
 */
import edit from "./components/edit";
import metadata from "./block.json";
import save from "./components/save";

// Import CSS.
import "./styles/style.scss";
import "./styles/styles.editor.scss";

import { GalleryAttributes } from "../../utils/components/block-gallery/shared";

/**
 * WordPress dependencies
 */
import { __ } from "@wordpress/i18n";

const attributes = {
  ...GalleryAttributes,
  ...metadata.attributes,
};
import { registerBlockType } from "@wordpress/blocks";

registerBlockType("easy-gtblocks/image-slider", {
  /* translators: block name */
  title: __("Image Slider", "easy-gtblocks"),
  category: "Easy_GTBlocks",
  /* translators: block description */
  description: __("Display multiple images.", "easy-gtblocks"),
  attributes,
  icon: "slides",
  keywords: [
    "easy-gtblocks",
    /* translators: block keyword */
    __("gallery", "easy-gtblocks"),
    /* translators: block keyword */
    __("photos", "easy-gtblocks"),
  ],
  supports: {
    align: ["wide", "full"],
    html: false,
  },
  example: {
    attributes: {
      gridSize: "lrg",
      gutter: 5,
      images: [
        {
          url:
            "https://s.w.org/images/core/5.3/Biologia_Centrali-Americana_-_Cantorchilus_semibadius_1902.jpg",
        },
        { url: "https://s.w.org/images/core/5.3/Glacial_lakes,_Bhutan.jpg" },
        { url: "https://s.w.org/images/core/5.3/MtBlanc1.jpg" },
      ],
    },
  },
  edit,
  save,
});
