/**
 * BLOCK: Easy GT Blocks Post and Page Grid
 */

// Import block dependencies and components
import edit from "./components/edit";

// Import CSS
import "./styles/style.scss";
import "./styles/styles.editor.scss";

// Components
const { __ } = wp.i18n;

// Register block controls
const { registerBlockType } = wp.blocks;

// Register alignments
const validAlignments = ["center", "wide", "full"];

// Register the block
registerBlockType("easy-gtblocks/post-carousel", {
  title: __("Post Carousel", "easy-gtblocks"),
  description: __(
    "Display posts as a carousel.",
    "easy-gtblocks"
  ),
  icon: "slides",
  category: "Easy_GTBlocks",
  keywords: [
    __("slider", "easy-gtblocks"),
    __("posts", "easy-gtblocks"),
    __("blog", "easy-gtblocks"),
    __("latest", "easy-gtblocks"),
    __("carousel", "easy-gtblocks"),
    __("responsive", "easy-gtblocks"),
  ],
  example: {},

  getEditWrapperProps(attributes) {
    const { align } = attributes;
    if (-1 !== validAlignments.indexOf(align)) {
      return { "data-align": align };
    }
  },

  edit,

  // Render via PHP
  save() {
    return null;
  },
});
